#!/usr/bin/perl
#
# epppt.pl - PowerPoint  HTMLץ
#
    @MAINTAINERS = ('Morikawa Yasuhiro <morikawa@ep.sci.hokudai.ac.jp>',
		   );
    $UPDATE      = '2005/07/01';
    $VERSION     = '3.6';
    $URL         =
    'http://www.ep.sci.hokudai.ac.jp/~morikawa/perl/epppt/SIGEN_PUB.htm';
#
#  
#
#    PowerPoint  PNG(ʤɤ) 򸫤䤹
#    饤ɷ, ӥͥ HTML 륹ץ
#
#  ˡ
#
#      $ epppt.pl -r Ȥ뤳. ϤĹΤǥѥפǥڡϤ
#      ɤǤ礦. ) $ epppt.pl -r | jless
#
#
#  Х?
#
#     Page 001, Page 002 Ϥʤ
#
#  History
#
#    - 3.6  2005/07/01
#           - convert  -depth <value> ץѲǽˤ.
#             ˤꡢʸΥڡ 8-bit ٤β
#             Ѵ뤳Ȥǽˤʤä. ե $depth ˤ
#             ٤ǽǤ.
#
#    - 3.5  2004/11/06
#           - ʸʤɤޤޤ硢alt °˽񤭽Фʤ褦
#             Ūˤϡ<ס>ס"ס&ס'פ
#             ʸ񤭽Фʤ褦ˤ롣
#           - ե̾Υ͡ѹե̾礹
#             ݤˤϡٹФ褦ˤ(¹ԤϤ)
#           - ܼǤ menu.html ββ˿򤤤褦ˤƤߤ
#
#    - 3.4  2004/11/06
#           - menu.txt ޤȤɤ߹ޤʤХ
#
#    - 3.3  2004/10/13
#           - ͥξ岼 001.html ɽ褦
#             إåեåɵ
#           - Хå򤹤Τʤ褦 quiet ⡼ɤ
#           - README.TXT  epppt.pl Τˤ
#
#    - 3.2  2004/10/13
#           - Config.epppt ΥǥեȤ src/Config.epppt Ȥ.
#           - ƥȤȲξɽ褦ˤ.
#           - ˽Ф̤Ǥ褦.
#           - ǥեȤΥ˥塼ʸǤ褦ˤ.
#
#    - 3.1  2004/10/12
#           - IE  menu.html ɽʤΤ
#
#    - 3.0  2004/10/12
#           - menu.html ˥ͥ⤵˾
#             Ѥ뤳Ȥˤ. (keynote Υѥ)
#
#    - 2.0  2004/10/11
#           - menu.txt ̵Ȥ⤽ʤ˺褦ˤ
#             - ̵Ǻä˿ (dcphoto Ʊͤ)
#           - convert ѤƲưŪ˳̾.
#           - ܸ̾ե (ä Shift-JIS Τ) Ǥ褦
#             (SOI ġ뤫Ω)
#
#    - 1.4  2004/03/22
#           menu.txt ν񼰤ְäƤ˥顼Ǥ褦˽.
#
#    - 1.3  2004/02/09
#           menu.txt ΥץϤǤ褦ѹ.
#           ץѹ.
#
#    - 1.2  2004/02/09
#           ƽϥե, This page is generated with
#           epppt ... Τ褦ʥåϤ褦ˤ.
#

##################################################
#####                                        #####
##                                     ###
#####                                        #####
##################################################
#
# ܸΤ, jcode Ȥ߹.
require 'jcode.pl'
    || die "Error: jcode.pl is not found.\n".
           "(If your OS is Debian GNU/Linux, you must install \"libjcode-perl\")\n";

# ץΤ, getopts Ȥ߹.
require 'getopts.pl'
    || die "Error: getopts.pl is not found.\n";

# 󸻥ǥ쥯ȥ̾
$SRC_DIR = 'src';

# ե̾
$CONFIG_FILE = "$SRC_DIR/Config.epppt";

# Ѵޥ
$CONVERT = 'convert';
$CONVERT_OPT = '-geometry';

# ǥХå⡼
$DEBUG = 0;

##################################################
#####                                        #####
##                                     ###
#####                                        #####
##################################################

# c, d Τ߰Ȥ.
&Getopts('c:d:vVxrRmMDq');

# ̵ϥإɽ
unless ($opt_x || $opt_c || $opt_d ||
	$opt_v || $opt_V || $opt_r || $opt_R || $opt_m || $opt_M ||
	$opt_D || $opt_q) {
    &Help;
    exit 1;
}
# D ץξ $DEBUG 򿿤
if ($opt_D) {
    $DEBUG = 1;
}
# q ץξ $QUIET 򿿤
if ($opt_q) {
    $QUIET = 1;
} else {
    $QUIET = 0;
}
#  v  V ξˤϥСɽ
if ($opt_v || $opt_V) {
    &PrintVersion;
    exit 1;
}
#  r  R ξˤ README.TXT 򥳥ԡΤ
if ($opt_r || $opt_R) {
    &PrintReadme;
    exit 1;
}
#  m  M ξˤ menu.txt Υƥץ졼Ȥ
if ($opt_m || $opt_M) {
    &PrintMenuTxt("$SRC_DIR/menu.txt", $DEBUG);
    exit 1;
}
# c ץξ $CONFIG_FILE ѹ
if ($opt_c) {
    $CONFIG_FILE = $opt_c;
}

# d ץξ $SRC_DIR ѹ
if ($opt_d) {
    $SRC_DIR = $opt_d;
    #  "/" ӽƤ
    $SRC_DIR =~ s|/+$||;
}

sub Help() {
    print STDOUT <<EOF;
  epppt.pl:
    USAGE:
      epppt.pl [-vVrRmM] [-x] [-q] [-c configfile] [-d srcdir] [-D]

    OPTION:
      -v, -V        : СʥСɽ
      -r, -R        : README.TXT ɽ
      -m, -M        : menu.txt ƥץ졼Ȥ
      -c configfile : եƼ¹
      -d srcdir     : ե־ (ǥեȤ $SRC_DIR)
      -D            : ǥХå⡼ (ȯ)
      -x            : ¹ (ե $CONFIG_FILE)
      -q            : 䤤碌̵Ǽ¹ (ǥեȤǽ)

EOF
    &PrintVersion;
}
sub PrintVersion() {
    print STDOUT <<EOF;
  epppt.pl Version $VERSION, Last Update: $UPDATE.

EOF
    foreach $MAINTAINER (@MAINTAINERS) {
	print STDOUT "  $MAINTAINER \n";
    }
    print STDOUT "    All Right Reserved.\n\n";
}

sub PrintMenuTxt() {
    local($menu_txt, $debug) = @_;
    print STDOUT "ڡʬ $menu_txt Ϥޤ? [30]: ";
    $pagenum = <STDIN>;
    # 㳰
    $pagenum = "30" unless ($pagenum =~ /^\d+$/);
    # ˥ե뤬, ̥ե
    local($i) = 0;
    while (-f $menu_txt) {
	$i++;
	$menu_txt = "$menu_txt"."."."$i";
    }
    # $menu_txt ǥ쥯ȥޤϤ.
    local(@menu_path) = split(/\//, $menu_txt);
    local($dirpath) = "";
    local($first) = 1;
    while($#menu_path > 0){
	local($dir) = shift(@menu_path);
	$dirpath = $dir if $first;
	$dirpath .= '/' . "$dir" unless $first;
	mkdir($dirpath) unless -d $dirpath;
	print STDOUT "  mkdir $dirpath \n" if ($debug);
	$first = 0;
    }
    # ե륪ץ & ͤν
    print STDOUT "Creating $menu_txt ...";
    open(MENUTXT, "> $menu_txt")
	|| die "顼: $menu_txt ˽񤭹ळȤޤǤ. /n";
    local($j) = 1;
    for (1..${pagenum}) {
	local($outnum) = sprintf "%03d:\n", $j;
	print MENUTXT "$outnum";
	$j++;
    }
    close(MENUTXT);
    print STDOUT "done\n";
}

##################################################
#####                                        #####
##             եǧ                ###
#####                                        #####
##################################################

unless (-f $CONFIG_FILE) {
    unless ($QUIET) {
	print STDOUT "եǤ $CONFIG_FILE ޤ.\n".
	             "  1. epppt ǥեȤǽ򤹤ʤ \"y\",\n".
		     "  2. Ǥʤ                     \"n\",\n".
		     "  3. $CONFIG_FILE ƥץ졼ȤϤʤ\"m\"\n".
		     "ϤƤ [Y/n/m]: ";
	$ans = <STDIN>;
    } else {
	$ans = "";
    }

    if ($ans =~ /^[mM].*$/) {
	print STDOUT "Creating $CONFIG_FILE ...";
	&OutputConfig($CONFIG_FILE, $VERSION, $UPDATE, $MAINTAINER, $DEBUG);
	print STDOUT "done\n";
	exit 0;
    }
    if ($ans =~ /^[nN].*$/) {
	die "顼: Ǥޤ.\n";
    }
}


##################################################
#####                                        #####
##             ǥե                ###
#####                                        #####
##################################################

##############################
###   (ץå)
##
#
#  $SRC_DIR ΥǥեȤ src Ǥ, epppt.pl  -d
#    ץͿФΰ
#
# ե
$infofile = "${SRC_DIR}/menu.txt";

# ȥե
$titlefile = "${SRC_DIR}/title.txt";

##############################
###   (ȥץå)
##
# ־ǥ쥯ȥ
$pubdir = "pub";

# ǥåե
$indexfile = "${pubdir}/index.html";

# ˥塼ե (᡼)
$menufile = "${pubdir}/menu.html";
#$menufile = "";      # ǥ˥塼ե뤬ʤ

# ˥塼ե (ƥ)
$menutxtfile = "${pubdir}/menutxt.html";
#$menutxtfile = "";   # ƥǥ˥塼ե뤬ʤ

# ͥե̾
$thumbnail_file = "${pubdir}/thumbnail.html";

#  HTML ե־ǥ쥯ȥ
$htmldir = "${pubdir}/html";

# ˥塼ե־ǥ쥯ȥ
$menudir = "${pubdir}/menu";

# 饤ɲե־ǥ쥯ȥ
$slidedir = "${pubdir}/slide";

# ͥե־ǥ쥯ȥ
$thumbdir = "${pubdir}/thumbnail";

##############################
###  
##
# ˥塼Υ
$menusize = "120x90";
# 饤ɤΥ
$slidesize = "640x480";
# ͥΥ
$thumbsize = "200x150";

##############################
###  ٤
##
$depth = "8";      # 0: -depth ץѤʤ

##############################
###  ʸ
##
# Ϥեܸʸ
# "jis", "euc", "sjis" Τɤ줫
$jpcode = "euc";
$system_code = "euc";

##############################
###  
##
# ưΥǥեȤΥڡ
# ڡ
$defaultleft  = "$menufile";     # ᡼˥塼
#$defaultleft  = "$menutxtfile";  # ƥȥ˥塼
# ڡ
$defaultright = "$thumbnail_file";    # ͥ
#$defaultright = "$htmldir/001.html";  # 1 ڡ


## 
# 0: ̵, 1: 뤢
$style_mode = "1";
    # ƥȤο
$style_textcolor       = '#339933';
    # طʿ
$style_bgcolor         = '#FFFFFF';
    # ϤΥ󥯿
$style_linkcolor       = '#666600';
    # ˻ȤΥ󥯿
$style_visitedcolor    = '#666633';
    # ޥ˾褻Υ󥯿
$style_hovercolor      = '#CCFFCC';
    # 󥯤... none: ̵, underline: ,
    #             blink: , overline:,
    #             line-through: Ǥä
$style_link_underline  = 'none';
    # 󥯤... normal: , bold: 
$style_link_fontweight = 'bold';

# ΥڡؤΥ󥯤Ѥʸ
$previouslink = '[Prev]';
$nextlink     = '[Next]';

# ƥڡΥ󥯤ξ岼դ
$upperlink = 'Parent Dirctory';
$upperurl  = '';
$lowerlink = 'ppt file';
$lowerurl  = '';

# Ϥƥڡղäå
#   - acktext ˤ, åΤΤϤʤ
#   - acklink ꤵƤդĤΥ "::" 
#     Ϥޤ줿ʬ acklink ؤΥ󥯤Ѵ
#   - $VERSION  epppt.pl ΥС󤬽Ϥ
#   - $URL  epppt.pl ֤ URL Ϥ
$acktext = "This page is generated with ::epppt:: Version $VERSION";
$acklink = "$URL";

##############################
###  ͥ
##
# 0: ̵ͥ, 1: ͥ뤢
$thumbnail_mode    = "1";
    # ͥؤΥ󥯤Υå
$thumbnail_link    = "[[ Thumbnail ]]";
    # ͥο
$thumbnail_col_num = "3";


##############################
###  ԡȯ
##
# եη
$len = 3;
# ʲγĥҤĤΤեȤ.
@treat = ('gif', 'GIF', 'jpg', 'JPG', 'jpeg', 'JPEG',
	  'png', 'PNG', 'bmp', 'BMP', 'tif', 'TIF',
	  'tiff', 'TIFF');



##################################################
#####                                        #####
###       桼եɤ߹           ###
#####                                        #####
##################################################

# 桼ե뤬ɤ߹Ϥɤ߹
if (-r $CONFIG_FILE) {
    require "$CONFIG_FILE";
}


##################################################
#####                                        #####
##                㳰                     ###
#####                                        #####
##################################################

# ʸɤ㳰
unless ($jpcode eq 'euc' || $jpcode eq 'sjis' || $jpcode eq 'jis') {
    print STDOUT "Modify \$jpcode from $jpcode to euc" if ($DEBUG);
    $jpcode = 'euc';
}

##################################################
#####                                        #####
##             ץ                  ###
#####                                        #####
##################################################


##################################################
## ɸϤޤϥȥե뤫饿ȥ
##################################################

$title = &TitleGet($titlefile, $jpcode, $QUIET, $DEBUG);

##################################################
## $SRC_DIR Υե̾򥷥ƥʸ
## (ǥեȤ EUC) ˥͡
##################################################

&RenameCurrentCode($SRC_DIR, $system_code, $DEBUG);

##################################################
## pub  slide  thumbnail ѤΥǥ쥯ȥ꤬
## ̵Ͽ. ˤϺ
## 뤫ɤ䤤碌. ʤˤ
## convert Ϥʤʤ.
##################################################

#
#  convert ϻ֤뤿, ˥ǥ쥯ȥ꤬
# ¸ߤˤϺѴʤ褦˽.
#
if (-d $pubdir && -d $menudir && -d $slidedir
    && -d $thumbdir || !$thumbnail_mode){
    unless ($QUIET) {
	print STDOUT " $slidedir ¸ߤƤޤ.\n".
	    "Ѵޤ? (ѴˤϾ֤ޤ.) [y/N]: ";
	$ans = <STDIN>;

	if ($ans =~ /^[yY].*$/) {
	    $NoConvert = 0;
	} else {
	    $NoConvert = 1;
	}
    } else {
	$NoConvert = 1;
    }
    print STDOUT "  \$NoConvert is $NoConvert.\n" if ($DEBUG);
}

mkdir($pubdir) unless -d $pubdir;
mkdir($menudir) unless -d $menudir;
mkdir($slidedir) unless -d $slidedir;
if ($thumbnail_mode) {
    mkdir($thumbdir) unless -d $thumbdir;
}

##################################################
## $SRC_DIR βե̾Τߤ
##################################################

#
# $SRC_DIR ǥ쥯ȥ⤫եΰФ,
# @srcimgs 
#
@srcimgs = &GetImageList($SRC_DIR, $DEBUG);


##################################################
## Ŭڤʲե̾
##################################################
#
# @srcimgs ̾ŬڤѹΤ @pubimgs
# ȤƼ.
#
#     饤1.PNG  ->   001.png
#      mgp00001.jpg  ->   001.jpg
#             1.GIF  ->   001.gif
#

@pubimgs = &RenameImage(@srcimgs);


##################################################
## $SRC_DIR  @srcimgs  $slidedir 
## $thumbdir  @pubimgs ȥ͡षưư.
## ưκݤ convert ǲѴ
##################################################
if ($depth){
    $convert_depth = "-depth $depth"
} else {
    $convert_depth = ""
}

#
#  @srcimsg  @pubimgs Ϥ,
# 2ĤϤΤ perl λ;ݤʤΤ
# ֥롼⤫ľܸƤ
#
unless ($NoConvert){
    &ConvertImage($SRC_DIR, $menudir, $menusize,
		  $CONVERT, $convert_depth . " " . $CONVERT_OPT, $DEBUG);
    
    &ConvertImage($SRC_DIR, $slidedir, $slidesize,
		  $CONVERT, $convert_depth . " " . $CONVERT_OPT, $DEBUG);
    
    if ($thumbnail_mode){
	&ConvertImage($SRC_DIR, $thumbdir, $thumbsize,
		     $CONVERT, $convert_depth . " " . $CONVERT_OPT, $DEBUG);
    }
}

##################################################
## slide, thumbnail ǥ쥯ȥ⤫
## եΥפФ
##################################################

$imgtype_menu  = &GetImageType($menudir, $DEBUG);
$imgtype_slide = &GetImageType($slidedir, $DEBUG);
$imgtype_thumb = &GetImageType($thumbdir, $DEBUG) if ($thumbnail_mode);

##################################################
## slide, thumbnail ǥ쥯ȥ⤫
## եΥפФ
##################################################

#
# ե $file_num .
# 
$file_num = $#pubimgs + 1;

##################################################
## ե뤫, ʥСȥ֥ȤФ.
##################################################

#
# ե뤬̵Ͽ.
#
&CreateInfo($infofile, $file_num, $DEBUG);

#
# ե뤫, ʥСȥ֥ȤФ @info 
#
@info = &GetInfo($infofile, $jpcode, $DEBUG);

#
# @info ˳ǼʥСȥ֥ȤʬΥ
# @number@subject%info_hash 
#
# - Хѿ @info  @number  @subject  %info_hash 
#    (Ϥä, ϤʤäΤǥܤ)
#
&SplitInfo($DEBUG);

#
# ʸɤ jpcode Ѥ meta ˽񤭹ѤѴ.
#
$metajp = &JpcodeToMeta($jpcode, $DEBUG);

#
# Ȥƽ񤭽Фʸ
#
$style_out = &StyleMake($style_mode, $style_textcolor, $style_bgcolor,
			$style_linkcolor, $style_visitedcolor,
			$style_hovercolor, $style_link_underline,
			$style_link_fontweight, $DEBUG);

$style_out_menu =
    &StyleMakeForMenu($style_mode, $style_textcolor, $style_bgcolor,
			$style_linkcolor, $style_visitedcolor,
			$style_hovercolor, $style_link_underline,
			$style_link_fontweight, $DEBUG);

#
# ǥåκ
#

&MakeIndex($title, $style_out, $metajp,
	   $indexfile, $defaultleft, $defaultright, $DEBUG);

#
# img  alt °ˡ<ס>ס"ס&ס'פʸ
# 񤭽Фʤ褦ˤ뤿ᡢ餬ʤʸ %altmsg 
# Ǽ
#
#    - Хѿ @number  %info_hash  %altmsg 
#      (Ϥä, ϤʤäΤǥܤ)
#
&MakeAltMsg($DEBUG);

#
# ĥ˥塼κ
#    - Хѿ @number  %info_hash  %altmsg 
#      (Ϥä, ϤʤäΤǥܤ)

if ($menufile) {
    &MakeMenu($menudir, $htmldir, $title, $style_out_menu,
	      $jpcode, $metajp, $imgtype_menu,
	      $upperlink, $upperurl, $lowerlink, $lowerurl,
	      $thumnail_mode, $thumbnail_file, $thumbnail_link,
	      $menufile, $menutxtfile, $DEBUG);
}

#
# ˥塼κ
#    - Хѿ @number  %info_hash 
#      (Ϥä, ϤʤäΤǥܤ)

if ($menutxtfile) {
    &MakeMenuTxt($title, $style_out, $jpcode, $metajp,
		 $upperlink, $upperurl, $lowerlink, $lowerurl,
		 $thumnail_mode, $thumbnail_file, $thumbnail_link,
		 $menutxtfile, $menufile, $DEBUG);
}
#
#  HTML κ
#    - Хѿ @number  %info_hash  %altmsg 
#      (Ϥä, ϤʤäΤǥܤ)

&MakeHtml($htmldir, $title, $style_out,
	  $previouslink, $nextlink, $imgtype_slide,
	  $acktext, $acklink, $jpcode, $metajp, $DEBUG);

#
# ͥκ
#    - Хѿ @number  %info_hash  %altmsg 
#      (Ϥä, ϤʤäΤǥܤ)

&MakeThumbnail($title, $style_out_menu, $jpcode, $metajp, $htmldir,
	       $thumnail_mode, $thumbnail_file, $thumbdir,
	       $thumbnail_link, $thumbnail_col_num,
	       $imgtype_thumb, $acktext, $acklink, $DEBUG);

#
# λ
#
&EndMessage($DEBUG);


##################################################
#####                                        #####
##             ֥롼                  ###
#####                                        #####
##################################################

sub OutputConfig() {
    local($configfile, $version, $update, $maintainer, $debug) = @_;
    # $configfile ǥ쥯ȥޤϤ.
    local(@config_path) = split(/\//, $configfile);
    local($dirpath) = "";
    local($first) = 1;
    while($#config_path > 0){
	local($dir) = shift(@config_path);
	$dirpath = $dir if $first;
	$dirpath .= '/' . "$dir" unless $first;
	mkdir($dirpath) unless -d $dirpath;
	print STDOUT "  mkdir $dirpath \n" if ($debug);
	$first = 0;
    }
    open(CONFIGFILE, "> $configfile")
	|| die "顼: $configfile ˽񤭹ळȤޤǤ. \n";
    print CONFIGFILE <<EOF;
#####   $configfile for epppt.pl    #####
##
#  This is Template File for epppt ver $VERSION
#
#  (C) Copyright by @MAINTAINERS
#  $UPDATE.  All rights reserved.
#
EOF

    print CONFIGFILE <<'EOF';
##############################
###   (ץå)
##
#
#  $SRC_DIR ΥǥեȤ src Ǥ, epppt.pl  -d
#    ץͿФΰ
#
# ե
$infofile = "${SRC_DIR}/menu.txt";

# ȥե
$titlefile = "${SRC_DIR}/title.txt";

##############################
###   (ȥץå)
##
# ־ǥ쥯ȥ
$pubdir = "pub";

# ǥåե
$indexfile = "${pubdir}/index.html";

# ˥塼ե (᡼)
$menufile = "${pubdir}/menu.html";
#$menufile = "";      # ǥ˥塼ե뤬ʤ

# ˥塼ե (ƥ)
$menutxtfile = "${pubdir}/menutxt.html";
#$menutxtfile = "";   # ƥǥ˥塼ե뤬ʤ

# ͥե̾
$thumbnail_file = "${pubdir}/thumbnail.html";

#  HTML ե־ǥ쥯ȥ
$htmldir = "${pubdir}/html";

# ˥塼ե־ǥ쥯ȥ
$menudir = "${pubdir}/menu";

# 饤ɲե־ǥ쥯ȥ
$slidedir = "${pubdir}/slide";

# ͥե־ǥ쥯ȥ
$thumbdir = "${pubdir}/thumbnail";

##############################
###  
##
# ˥塼Υ
$menusize = "120x90";
# 饤ɤΥ
$slidesize = "640x480";
# ͥΥ
$thumbsize = "200x150";

##############################
###  ٤
##
$depth = "8";      # 0: -depth ץѤʤ

##############################
###  ʸ
##
# Ϥեܸʸ
# "jis", "euc", "sjis" Τɤ줫
$jpcode = "euc";
$system_code = "euc";

##############################
###  
##
# ưΥǥեȤΥڡ
# ڡ
$defaultleft  = "$menufile";     # ᡼˥塼
#$defaultleft  = "$menutxtfile";  # ƥȥ˥塼
# ڡ
$defaultright = "$thumbnail_file";    # ͥ
#$defaultright = "$htmldir/001.html";  # 1 ڡ


## 
# 0: ̵, 1: 뤢
$style_mode = "1";
    # ƥȤο
$style_textcolor       = '#339933';
    # طʿ
$style_bgcolor         = '#FFFFFF';
    # ϤΥ󥯿
$style_linkcolor       = '#666600';
    # ˻ȤΥ󥯿
$style_visitedcolor    = '#666633';
    # ޥ˾褻Υ󥯿
$style_hovercolor      = '#CCFFCC';
    # 󥯤... none: ̵, underline: ,
    #             blink: , overline:,
    #             line-through: Ǥä
$style_link_underline  = 'none';
    # 󥯤... normal: , bold: 
$style_link_fontweight = 'bold';

# ΥڡؤΥ󥯤Ѥʸ
$previouslink = '[Prev]';
$nextlink     = '[Next]';

# ƥڡΥ󥯤ξ岼դ
$upperlink = 'Parent Dirctory';
$upperurl  = '';
$lowerlink = 'ppt file';
$lowerurl  = '';

# Ϥƥڡղäå
#   - acktext ˤ, åΤΤϤʤ
#   - acklink ꤵƤդĤΥ "::" 
#     Ϥޤ줿ʬ acklink ؤΥ󥯤Ѵ
#   - $VERSION  epppt.pl ΥС󤬽Ϥ
#   - $URL  epppt.pl ֤ URL Ϥ
$acktext = "This page is generated with ::epppt:: Version $VERSION";
$acklink = "$URL";

##############################
###  ͥ
##
# 0: ̵ͥ, 1: ͥ뤢
$thumbnail_mode    = "1";
    # ͥؤΥ󥯤Υå
$thumbnail_link    = "[[ Thumbnail ]]";
    # ͥο
$thumbnail_col_num = "3";


##############################
###  ԡȯ
##
# եη
$len = 3;
# ʲγĥҤĤΤեȤ.
@treat = ('gif', 'GIF', 'jpg', 'JPG', 'jpeg', 'JPEG',
	  'png', 'PNG', 'bmp', 'BMP', 'tif', 'TIF',
	  'tiff', 'TIFF');

EOF

    print CONFIGFILE <<EOF;
######################################################################
# ƤӽФߤ require '${configfile}'  1 ֤褦ˤ.
# ǤʤХե뤬ĤäƤʤȤȽꤵ.
1;
EOF

    close(CONFIGFILE);
}


# ɸϤޤϥȥե뤫饿ȥ
#
# 
#	$titlefile	ȥ뤬񤭹ޤƤե
#
# ֵ
#	եΰܤޤɸϤ, Ԥ֤
#
sub TitleGet {
    local($titlefile, $jpcode, $quiet, $debug) = @_;
    local($title);
    #
    # ȥե뤬ʤ, ɸϤϤ.
    #
    unless  (-f "$titlefile") {
	unless ($quiet) {
	    print "ȥƲ.\n  Title []: ";
	    $input = <STDIN> ;
	    chomp($input) ;
	} else {
	    $input = "" ;
	    chomp($input) ;
	}
	&jcode'convert(*input, "$jpcode");
	open(TITLE, "> $titlefile") ||
	    die "顼: $titlefile ˽񤭹ळȤǤޤǤ. \n";
	print TITLE "$input" ;
	close(TITLE);
    }
    #
    # ȥե뤫饿ȥФ.
    #
    print STDOUT "Get Title form $titlefile ...";
    open(TITLEFILE, "$titlefile")
	|| die "顼: $titlefile ĤޤǤ. \n";
    while (<TITLEFILE>) {
	chomp;
	# ʸѴ
	&jcode'convert(*_, "$jpcode");
	push(@title_lists, $_);
    }
    # ܤФ.
    $title = $title_lists[0];
    close(TITLEFILE);
    # ǥХåå
    print STDOUT "TitleGet: \$title = $title\n" if ($debug);
    # ֵͤ
    print STDOUT "done.\n";
    return $title;
}

#
# ե̾򥷥ƥΥɤľ.
#
# 
#	$dir		ǥ쥯ȥ
#	$code		ʸ
#
# ֵ
#	$dir Υե̾ $code ̾ѹ
#
#
sub RenameCurrentCode() {
    local($dir, $code, $debug) = @_;
    local($srcfile, $srcfile_org, $ok);
    print STDOUT "Rename file in $dir to $code ...";
    
    opendir(SRCDIR, "$dir")
	|| die "顼: $dir ǥ쥯ȥ꤬¸ߤޤ. \n";
    # ʸɤ Shift-JIS Ǥͤ, äϥե̾
    # Τޤ޼
    local(@srcfiles) = readdir(SRCDIR);
    closedir(SRCDIR);

    # ե̾򥷥ƥΥ (ǥեȤ EUC) ѹ
    foreach $srcfile (@srcfiles) {
	$srcfile_org = $srcfile;
	&jcode'convert(*srcfile, "$code");
	$ok = rename("$dir/$srcfile_org", "$dir/$srcfile");
	if ($debug) {
	    print STDOUT "    $dir/$srcfile_org -> $dir/$srcfile";
	    print STDOUT "\t \[Failure\]" if $ok == 0;
	    print STDOUT "\n";
	}
    }
    
    print STDOUT "done.\n";
}

#
# $dir ⤫ե̾ΥꥹȤФ
#
# 
#	$dir		ǥ쥯ȥ
#
# ֵ
#	$dir βե̾ΥꥹȤ֤
#
sub GetImageList(){
    local($dir, $debug) = @_;
    local(@treat) = @treat;
    local($srcfile, $imgtype);
    
    print STDOUT "Get Names of Image in $dir ...";
    opendir(DIR, "$dir")
	|| die "顼: $dir ǥ쥯ȥ꤬¸ߤޤ. \n";
    local(@srcfiles) = grep(!/^\.\.?$/, sort(readdir(DIR)));
    closedir(DIR);
    
    #
    # եΤ @srcfiles_img ˴ޤ.
    # , @treat γĥҤĤȤ, ե̾˿ޤळȤǤ.
    #
    undef local(@srcfiles_img);
    foreach $srcfile (@srcfiles){
	local($img_ok) = 0;
	local(@srcfile_parts) = split(/\./, $srcfile);
	local($srcfilename) = $srcfile_parts[$#srcfile_parts - 1];
	local($srcfile_imgtype) = $srcfile_parts[$#srcfile_parts];
	foreach $imgtype (@treat){
	    if ($srcfile_imgtype eq $imgtype){
		if ($srcfilename =~ /^.*\d+.*$/){
		    $img_ok = 1;
		}
	    }
	}
	if ($img_ok) {
	    push(@srcfiles_img, $srcfile);
	    print STDOUT "  $SRC_DIR/$srcfile is IMG file.\n" if ($debug);
	}
    }

    # ǥ쥯ȥ˲ե뤬̵ϥ顼֤
    unless ($srcfiles_img[0]) {
	die "顼: $dir ˤϲեȻפΤ¸ߤޤ. \n";
    }
    print STDOUT "  done.\n";
    return @srcfiles_img;
}


# ե͡ॵ֥롼
#
# 
#	@org	βե̾
#
# ֵ
#	@org ͡ष. ͡ϰʲΤ褦
#       ʤ
#
#         - 饤1.PNG  ->   001.png
#         -  mgp00001.jpg  ->   001.jpg
#         -         1.GIF  ->   001.gif
#
sub RenameImage() {
    local(@org) = @_;
    local($debug) = $DEBUG;
    local(@rename);            # ͡Υե̾
    local($len)   = $len;      # ͡षեη
    print STDOUT "Prepare Names of image files in publish directory ...";

    undef @rename;
    local($orgimg);
    foreach $orgimg (@org){
	local(@orgimg_parts) = split(/\./, $orgimg);
	local($orgimgname) = $orgimg_parts[$#orgimg_parts - 1];
	local($orgimgtype) = $orgimg_parts[$#orgimg_parts];
	#
	# ե̾, ͤǤʤΤ.
	#
	if ($orgimgname =~ /([1-9]\d*)/){
	    $orgimgname = $1;
	} else {
	    warn "$orgimg Ͽޤޤʤ, եȤƼ̤ޤ.\n";
	}
	#
	# եΥʥСηˤ
	#
	if ($len < length($orgimgname)){
	    # 顼ޡ
	    local($error) = 1;
	} else {
	    # 顼ޡβ
	    $error = 0;
	}
	local($new_orgimgname) = sprintf('%.' . $len . 'd', $orgimgname);
	
	#
	# ĥҤʸˤ
	#
	local($new_orgimgtype) = $orgimgtype;
	$new_orgimgtype =~ tr/A-Z/a-z/;

	#
	# ե̾ @rename ˳Ǽ.
	#
	push(@rename, "${new_orgimgname}\.${new_orgimgtype}");

	#
	# ǥХåѤΥå
	#
	if ($debug) {
	    print STDOUT "    $SRC_DIR/$orgimg -> ${new_orgimgname}\.${new_orgimgtype}";
	    print STDOUT "\t \[Irregular Rename...\]" if $error == 1 ;
	    print STDOUT "\n";
	}
    }
    print STDOUT "  done.\n";

    #
    # ̾ʣƤʤå
    #
    print STDOUT "Checking File Name Duplication ...";
    local($check1, $check2, $n1, $n2, @checkarray, $duplication);
    @checkarray = @rename;
    $duplication = 0;
    $n1 = 0;
    $n2 = $n1 + 1;
    while (@checkarray) {
	$check1 = shift(@checkarray);
#	print STDOUT "n1 = $n1 check1 = $check1\n" if ($debug);
	foreach $check2 (@checkarray) {
#	    print STDOUT "n2 = $n2 check2 = $check2\n" if ($debug);
	    if ($check1 eq $check2) {
		$duplication = $check1;
		last;
	    }
	    $n2++;
	}
	last if $duplication;
	$n1++;
	$n2 = $n1 + 1;
    }

#    print STDOUT "n1 = $n1\n" if ($debug);
#    print STDOUT "n2 = $n2\n" if ($debug);

    if ($duplication) {
	warn "\n       Warning!! \"$org[$n1]\"  \"$org[$n2]\" Ʊ̾ \"$duplication\" ˥͡वޤ\n\n";
    }
    print STDOUT "  done.\n";
    return @rename;
}


# ե륵Ѵ & ư֥롼
#
# 
#	$srcdir		ưǥ쥯ȥ
#	$todir		ѤΰưѤβե־
#	$imgsize	Υ (ѹ褦Ȥ륵)
#	$convert	convert Υޥ
#	$convert_opt	convert βѹѥץʸ
#	$debug		ǥХåץ
#
# ۤΰ
#	@srcimgs	$SRC_DIR βե
#	@pubimgs	$slidedir ʤɤǻѤե̾
#
# ֵ
#	ʤ.
#
sub ConvertImage() {
    local($srcdir, $todir, $imgsize,
	  $convert, $convert_opt, $debug) = @_;
    local($command) = "$convert $convert_opt";
    local($n) = 0;

    print STDOUT "Convert Image files from $srcdir to $todir ...  \n";
    
    while($srcimgs[$n]){
	print STDOUT "  $command $imgsize ".
	    "$srcdir/$srcimgs[$n] $todir/$pubimgs[$n]....  ";
	
	system("$command $imgsize $srcdir/$srcimgs[$n] $todir/$pubimgs[$n]");

	print STDOUT "done.\n";
	$n++;
    }
    print STDOUT "done.\n";
}

#
# ǥ쥯ȥ1ܤΥեβפФ
#
# 
#	$dir		ǥ쥯ȥ
#
# ֵ
#	ǥ쥯ȥ1ܤΥեγĥҤ֤

sub GetImageType() {
    local($dir, $debug) = @_;
    print STDOUT "Get ImageType from $dir ..." unless ($debug);
    # ǥ쥯ȥꥪץ
    opendir(DIR, "$dir")
	|| die "顼: $dir ǥ쥯ȥ꤬¸ߤޤ. \n";
    local(@imgfiles) = grep(!/^\.\.?$/, readdir(DIR));
    closedir(DIR);
    # ǥ쥯ȥ˲뤫å
    unless ($imgfiles[0]) {
	die "顼: $dir ǥ쥯ȥ˥ե뤬¸ߤޤ. \n";
    }
    # ܤΥե򸫤. (ݤ)
    local($sampleimg) = $imgfiles[0];
    local(@imgname_parts) = split(/\./, $sampleimg);
    local($imgtype) = $imgname_parts[$#imgname_parts];

    # ǥХåѽ
    print STDOUT "GetImageType: In $dir, ImageType is $imgtype.\n" if ($debug);
    print STDOUT "done.\n" unless ($debug);

    return $imgtype;
}


# $infofile (menu.txt) ֥롼
#
# 
#	$infofile ¸ߤʤ硢$file_num ˹碌 $infofile
#	롣$infofile ¸ߤϲ⤻֤
#
# 
#	$infofile	饤ɾǼե (ǥե menu.txt)
#	$file_num	饤ɤο
#	$debug		ǥХåץ
#
# ֵ
#	ʤ.
#
sub CreateInfo(){
    local($infofile, $file_num, $debug) = @_;
    #
    # $infofile ¸ߤϲ⤻˽λ
    #
    if (-f "$infofile") {
	print STDOUT "Slide Informations file $infofile is already exist.\n";
	return;
    }
    #
    # ¸ߤʤϥ饤ɿ˹碌 $infofile 
    # 
    print STDOUT "Create Slide Informations file $infofile ...  ";
    print STDOUT "  In $infofile ...  \n" if ($DEBUG);
    open(INFOFILE, "> $infofile")
	|| die "$infofile ˽񤭹ळȤǤޤǤ. \n";
    local($n) = 1 ;
    while ($n <= $file_num ) {
	local($number) = sprintf('%.' . $len . 'd', $n);
	print INFOFILE "${number}:\n";
	$n++;
	print STDOUT "    ${number}:\n" if ($debug);
    }
    close(INFOFILE);
    print STDOUT "done\n";
    return;
}

# $infofile  @info ؾ륵֥롼
#
# 
#	$infofile Υǡ @info ˰ԤŤĳǼ֤
#	⤷񼰤ְäƤϥ顼֤ƽλ롣
#	ʤκݡܸʸɤ $jpcode ѹƤޤ
#
# 
#	$infofile	饤ɾǼե (ǥե menu.txt)
#	$jpcode		ʸ
#	$debug		ǥХåץ
#
# ֵ
#	@info		$infofile γƹԤǼ
#			ʸɤ $jpcode Ѵ
#
sub GetInfo(){
    local($infofile, $jpcode, $debug) = @_;
    local(@info);
    print STDOUT "Get Slide Informations from $infofile ...  ";
    open(INFOFILE, "$infofile") || die "$infofile is not found.\n";
    while (<INFOFILE>) {
	# 㳰
	unless ($_ =~ /^(\d){3}:.*$/) {
	    die "$infofile γƹԤλϤ 001:.., 002:.. ȤʤäƤɬפޤ.\n"
	}
	chomp;
	# ʸѴ
	&jcode'convert(*_, "$jpcode");
	push(@info, $_);
	print STDOUT "    $_\n" if ($debug);
    }
    close(INFOFILE);
    print STDOUT "done\n";
    return @info;
}

#
# @info ˳ǼʥСȥ֥ȤʬΥ
# @number@subject%info_hash 
# ʤ֥Ȥξ硢Page 001Page 002 ʤɤʸͿ롣
#
# 
#	$debug		ǥХåץ
#
# ۤΰ ()
#	@info		ƹԥʥСȥ֥ȤǼƤ
#
# ۤΰ ()
#	@number		ƹԤΥʥСǼ
#	@subject	ƹԤΥ֥ȤǼ
#	%info_hash	ʥС򥭡ˡ֥Ȥͤ˳ǼϢ
#
# ֵ
#	ʤ.
#
sub SplitInfo(){
    local($debug) = @_;
    local($key);
    print STDOUT "Split Slide Informations ...  ";
    foreach $key (@info){
	local(@info_parts) = split(/:/, $key, 2);
	print STDOUT "    Number: $info_parts[0]\t Value: " if ($debug);
	# $info_parts[1] ξˤ "Page 001" Τ褦
	# ʸ򤤤Ƥ
	unless ($info_parts[1] =~ /\S+/){
	    $info_parts[1] = "Page " . "$info_parts[0]";
	    print STDOUT "[Not Found. Auto Generate...] " if ($debug);
	}
	$info_hash{"$info_parts[0]"} = "$info_parts[1]";
	push(@number, $info_parts[0]);
	push(@subject, $info_parts[1]);
	print STDOUT "$info_parts[1]\n" if ($debug);
    }
    print STDOUT "done\n";
    return;
}


#
# ʸɤ jpcode Ѥ meta ˽񤭹ѤѴ륵֥롼
#
sub JpcodeToMeta($jpcode, $debug) {
    print STDOUT "Recognize Japanese Code is $jpcode ..." unless ($debug);
    local($jpcode, $debug) = @_;
    local($metajp, %meta_jpcode_list);
    %meta_jpcode_list = (
			 'euc',		'euc-jp',
			 'sjis',	'Shift_JIS',
			 'jis',		'iso-2022-jp',
			);
    $metajp = $meta_jpcode_list{"$jpcode"};
    # ǥХåѽ
    print STDOUT "JpcodeToMeta: \$jpcode = $jpcode => \$metajp = $metajp\n" if ($debug);
    print STDOUT "done.\n" unless ($debug);
    return $metajp;
}

#
# ֥롼
#
# 
#	$mode		0: ̵, 1: 뤢
#	$textcolor	ƥȤο
#	$bgcolor	طʿ
#	$linkcolor	ϤΥ󥯿
#	$visitedcolor	˻ȤΥ󥯿
#	$hovercolor	ޥ˾褻Υ󥯿
#	$link_underline	󥯤... none: ̵, underline: ,
#				    blink: , overline:,
#				    line-through: Ǥä
#	$link_fontweight 󥯤... normal: , bold: 
#
#
# ֵ
#	Ȥƽ񤭽Фϥå
#
sub StyleMake() {
    local($mode, $textcolor, $bgcolor, $linkcolor, $visitedcolor,
	  $hovercolor, $link_underline, $link_fontweight, $debug) = @_;
    local($style_output);
    # Ѥ˽񤭽Фʸ.
    $style_output =
	'  <style type="text/css">'. "\n".
	'    <!--'. "\n".
        "      body{\n".
        "           color:$textcolor;\n".
        "           background-color:$bgcolor;\n".
        "          }\n".
        "      a:link{color:$linkcolor;}\n".
        "      a:visited{color:$visitedcolor;}\n".
        "      a:hover{color:$hovercolor;}\n".
        "      a{\n".
        "        text-decoration:$link_underline;\n".
        "        font-weight:$link_fontweight;\n".
        "      }\n".
        "    -->\n".
        "  </style>\n";

    # ꤷʤ, nul ʸ֤
    undef $style_output unless ($mode);

    # ǥХåѽ
    print STDOUT "StyleMake: \$style_output = \n $style_output\n" if ($debug);
    return $style_output;
}

#
# ˥塼եѥ֥롼
#
# 
#	$mode		0: ̵, 1: 뤢
#	$textcolor	ƥȤο
#	$bgcolor	طʿ
#	$hovercolor	ޥ˾褻Υ󥯿
#
#
# ֵ
#	˥塼եΥȤƽ񤭽Фϥå
#
sub StyleMakeForMenu() {
    local($mode, $textcolor, $bgcolor, $linkcolor, $visitedcolor,
	  $hovercolor, $link_underline, $link_fontweight, $debug) = @_;
    local($style_output);
    # Ѥ˽񤭽Фʸ.
    $style_output =
	'  <style type="text/css">'. "\n".
	'    <!--'. "\n".
        "      body{\n".
        "           color:$textcolor;\n".
        "           background-color:$bgcolor;\n".
        "          }\n".
        "      a:link{color:$linkcolor;}\n".
        "      a:visited{color:$visitedcolor;}\n".
        "      a:hover{color:$hovercolor;}\n".
        "      a:link img {border-color:$bgcolor;}\n".
        "      a:visited img {border-color:$bgcolor;}\n".
        "      a:hover img {border-color:$hovercolor;}\n".
        "      a{\n".
        "        text-decoration:$link_underline;\n".
        "        font-weight:$link_fontweight;\n".
        "      }\n".
        "    -->\n".
        "  </style>\n";

    # ꤷʤ, nul ʸ֤
    undef $style_output unless ($mode);

    # ǥХåѽ
    print STDOUT "StyleMakeForMenu: \$style_output = \n $style_output\n" if ($debug);
    return $style_output;
}


#
# ƥǥåե֥롼
#
sub MakeIndex {
    local($title, $style_out, $metajp,
	  $indexfile, $defaultleft, $defaultright, $debug) = @_;
    print STDOUT "Creating Index File ..." unless ($debug);
    open(INDEXFILE, "> $indexfile")
	|| die "顼: $indexfile ˽񤭹ळȤޤǤ. /n";
    #
    # إåν񤭽Ф
    #
    print INDEXFILE <<EOF;
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=${metajp}">
  <title>$title</title>
$style_out
</head>

<frameset cols="22%,78%">
<frame src="../$defaultleft" name="menu" scrolling="yes">
<frame src="../$defaultright" name="display" scrolling="yes">
</frameset>

</html>
EOF
    print STDOUT "done.\n" unless ($debug);
    close(INDEXFILE);
}

#
# img  alt °ˡ<ס>ס"ס&ס'פʸ
# 񤭽Фʤ褦ˤ뤿ᡢ餬ʤʸ %altmsg 
# Ǽ
#
# 
#	$debug		ǥХåץ
#
# ۤΰ ()
#	@number		ƹԤΥʥСǼ
#	%info_hash	ʥС򥭡ˡ֥Ȥͤ˳ǼϢ
#
# ۤΰ ()
#	%altmsg		alt °˽񤭽ФͤǼ
#
# ֵ
#	ʤ.
#
#
sub MakeAltMsg(){
    local($debug) = @_;
    local($num);
    print STDOUT "Creating Alt Attribute ...";
    foreach $num (@number){
	# <ס>ס"ס&ס'פʸ
	# alt °ˤϽ񤭽Фʤ
	if ($info_hash{$num} =~ /\<|\>|\"|\&|\'/) {
	    $altmsg{$num} = '';
	} else {
	    $altmsg{$num} = $info_hash{$num};
	}
	print STDOUT "           ${num} : $info_hash{$num}\n" if ($debug);
	print STDOUT "                    alt=\"$altmsg{$num}\"\n" if ($debug);
    }
    print STDOUT "done.\n";
    return;
}


#
# ĥ˥塼եκ֥롼
#    - Хѿ @number  %info_hash  %altmsg 
#      (Ϥä, ϤʤäΤǥܤ)
#
sub MakeMenu() {
    local($menudir, $htmldir, $title, $style_out,
	  $jpcode, $metajp, $imgtype_menu,
	  $upperlink, $upperurl, $lowerlink, $lowerurl,
	  $thumnail_mode, $thumbnail_file, $thumbnail_link,
	  $menufile, $anotherfile, $debug) = @_;
    print STDOUT "Creating Menu File ..." unless ($debug);
    # ʸѴ
    &jcode'convert(*upperlink, "$jpcode");
    &jcode'convert(*upperurl, "$jpcode");
    &jcode'convert(*lowerlink, "$jpcode");
    &jcode'convert(*lowerurl, "$jpcode");
    &jcode'convert(*thumbnail_link, "$jpcode");
    open(MENUFILE, "> $menufile")
	|| die "顼: $menufile ˽񤭹ळȤޤǤ. /n";
    #
    # κ˽񤭹 (ƬΥ)
    #
    local(%leftnum, $num, $left);
    undef %leftnum;
    foreach $num (@number) {
	$left = sprintf("%d", $num);
	$leftnum{$num} = $left;
    }
    #
    # إåν񤭽Ф
    #
    print MENUFILE <<EOF;
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=${metajp}">
  <title> $title Menu</title>
$style_out
</head>
<body>

EOF
    #
    # դ
    #
    if ($upperlink && $upperurl) {
	print MENUFILE <<EOF;
<small>
  <a href="../${upperurl}" target="_top">${upperlink}</a>
</small>

EOF
    }
    #
    # ͥ⡼ɤؤΥ
    #
    if ($thumbnail_mode && $thumbnail_file && $thumbnail_link) {
	print MENUFILE <<EOF;
<hr noshade size="1">
<center><small>
  <a href="../${thumbnail_file}" target="display">${thumbnail_link}</a>
</small></center>
<hr noshade size="1">

EOF
    }
    #
    # ᡼˥塼ؤΥ
    #
    if ($anotherfile) {
	print MENUFILE <<EOF;
<center><small>
  [Image] &nbsp;
  <a href="../$anotherfile" target="menu">[Text]</a>
</small></center></small></center>
<hr noshade size="1">

EOF
    }
    #
    # ܼ󥯤Υإåʬ񤭽Ф
    #
    print MENUFILE <<EOF;
<table cellpadding="0" cellspacing="0" width="100%" align="center">
EOF
    foreach $num (@number){
	print MENUFILE <<EOF;
<tr align="center">
  <td valign="top"><br><small>$leftnum{$num}</small></td>
  <td align="center">
    <a href="../${htmldir}/${num}.html" target="display">
    <img src="../${menudir}/${num}.${imgtype_menu}" border="15" alt="$altmsg{$num}">
    </a>
  </td>
</tr>

EOF
    }
    #
    # ܼʬΥեåν񤭽Ф
    #
    print MENUFILE <<EOF;
</table>

EOF
    #
    # դ
    #
    if ($lowerlink && $lowerurl) {
	print MENUFILE <<EOF;
<hr noshade size="1">
<small><div align="right">
  <a href="../${lowerurl}" target="_top">${lowerlink}</a>
</div></small>

EOF
    }
    #
    # եåν񤭽Ф
    #
    print MENUFILE <<EOF;
</body>
</html>
EOF
    close(MENUFILE);
    # ǥХåѽ
    if ($debug) {
	print STDOUT "MakeMenu:\n" ;
	foreach $num (@number){
	    print STDOUT "           ${num} : $info_hash{$num}\n";
	    print STDOUT "                    alt=\"$altmsg{$num}\"\n";
	}
    }
    print STDOUT "done.\n" unless ($debug);
}

#
# ˥塼եκ֥롼
#    - Хѿ @number  %info_hash 
#      (Ϥä, ϤʤäΤǥܤ)
#
sub MakeMenuTxt() {
    local($title, $style_out, $jpcode, $metajp,
	  $upperlink, $upperurl, $lowerlink, $lowerurl,
	  $thumnail_mode, $thumbnail_file, $thumbnail_link,
	  $menufile, $anotherfile, $debug) = @_;
    print STDOUT "Creating MenuTexT File ..." unless ($debug);
    # ʸѴ
    &jcode'convert(*upperlink, "$jpcode");
    &jcode'convert(*upperurl, "$jpcode");
    &jcode'convert(*lowerlink, "$jpcode");
    &jcode'convert(*lowerurl, "$jpcode");
    &jcode'convert(*thumbnail_link, "$jpcode");
    open(MENUFILE, "> $menufile")
	|| die "顼: $menufile ˽񤭹ळȤޤǤ. /n";
    #
    # إåν񤭽Ф
    #
    print MENUFILE <<EOF;
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=${metajp}">
  <title> $title Menu</title>
$style_out
</head>
<body>

EOF
    #
    # դ
    #
    if ($upperlink && $upperurl) {
	print MENUFILE <<EOF;
<small>
  <a href="../${upperurl}" target="_top">${upperlink}</a>
</small>

EOF
    }
    #
    # ͥ⡼ɤؤΥ
    #
    if ($thumbnail_mode && $thumbnail_file && $thumbnail_link) {
	print MENUFILE <<EOF;
<hr noshade size="1">
<center><small>
  <a href="../${thumbnail_file}" target="display">${thumbnail_link}</a>
</small></center>
<hr noshade size="1">

EOF
    }
    #
    # ᡼˥塼ؤΥ
    #
    if ($anotherfile) {
	print MENUFILE <<EOF;
<center><small>
  <a href="../$anotherfile" target="menu">[Image]</a> &nbsp;
  [Text]
</small></center></small></center>
<hr noshade size="1">

EOF
    }
    #
    # ܼ󥯤Υإåʬ񤭽Ф
    #
    print MENUFILE <<EOF;
<ol><small>
EOF
    foreach $num (@number){
	print MENUFILE <<EOF;
<li><a href="../${htmldir}/${num}.html" target="display">$info_hash{$num}</a><br>

EOF
    }
    #
    # ܼʬΥեåν񤭽Ф
    #
    print MENUFILE <<EOF;
</small></ol>

EOF
    #
    # դ
    #
    if ($lowerlink && $lowerurl) {
	print MENUFILE <<EOF;
<hr noshade size="1">
<small><div align="right">
  <a href="../${lowerurl}" target="_top">${lowerlink}</a>
</div></small>

EOF
    }
    #
    # եåν񤭽Ф
    #
    print MENUFILE <<EOF;
</body>
</html>
EOF
    close(MENUFILE);
    # ǥХåѽ
    if ($debug) {
	print STDOUT "MakeMenu:\n" ;
	foreach $num (@number){
	    print STDOUT "           ${num} : $info_hash{$num}\n";
	}
    }
    print STDOUT "done.\n" unless ($debug);
}


#
#  HTML ե֥롼
#    - Хѿ @number  %info_hash  %altmsg 
#      (Ϥä, ϤʤäΤǥܤ)
#
sub MakeHtml {
    local($htmldir, $title, $style_out,
	  $previouslink, $nextlink, $imgtype,
	  $acktext, $acklink, $jpcode, $metajp, $debug) = @_;
    # ǥХåѥåإå
    print STDOUT "MakeHtml:\n" if ($debug);

    # ʸѴ
    &jcode'convert(*previouslink, "$jpcode");
    &jcode'convert(*nextlink, "$jpcode");
    #
    # ǥ쥯ȥκȺ
    #
    print STDOUT "Removing Old HTML Files ..." unless ($debug);
    print STDOUT "  Remove ./${htmldir}, and Mkdir ${htmldir}" if ($debug);

    system("/bin/rm -rf ./${htmldir}/") if -d "./${htmldir}";
    mkdir("${htmldir}", 0755);

    print STDOUT "done.\n". "Creating HTML Files ..." unless ($debug);

    # ߤΥǥ쥯ȥξ
    local($current_dir) = `pwd`;
    chomp $current_dir;
    # ǥ쥯ȥư
    chdir("./${htmldir}");
    print STDOUT "  Move to $htmldir ...\n" if ($debug);

    # ֹȤ $element_num Ѱ
    local($element_num) = 0;


    while ($number[$element_num]) {
	local($allpage_num) = $#number + 1;
	local($previous_num) = $element_num - 1;
	local($next_num) = $element_num + 1;
	local($htmlnumber) = $number[$element_num];
	local($htmlfile) = "${htmlnumber}.html";
	#
	# إåκ
	#
	open(HTMLFILE, "> $htmlfile")
	    || die "顼: $htmlfile ˽񤭹ळȤޤǤ. /n";
	print HTMLFILE <<EOF;
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=${metajp}">
  <title>$title [$info_hash{$htmlnumber}]</title>
$style_out
</head>
<body>
EOF
	#
	# ΥڡؤΥ, ڡ/ڡ, ν񤭽Ф
	#
	print HTMLFILE <<EOF;

<hr noshade size="1">
<table width="90%">
  <tr>
    <td width="30%">
EOF
	# ǽΥڡȺǸڡξϥ󥯤ŽʤΤ
	# ʬ.

	# ǽΥڡ [] ˥󥯤Žʤ
	if ($previous_num < 0) {
	    print HTMLFILE <<EOF;
      ${previouslink}
      <A HREF="$number["$next_num"].html">${nextlink}</A>
EOF
	}
	# ǸΥڡ [] ˥󥯤Žʤ
	elsif ($next_num > $#number) {
	    print HTMLFILE <<EOF;
      <A HREF="$number["$previous_num"].html">${previouslink}</A>
      ${nextlink}
EOF
	}
	# ¾Ǥξ˥
	else {
	    print HTMLFILE <<EOF;
      <A HREF="$number["$previous_num"].html">${previouslink}</A>
      <A HREF="$number["$next_num"].html">${nextlink}</A>
EOF
	}


	print HTMLFILE <<EOF;
    </td>
    <td width="30%" align="center">
    $next_num / $allpage_num
    </td>
    <td align="right">
      $info_hash{$htmlnumber}
    </td>
  </tr>
</table>
<hr noshade size="1">

EOF
	#
	# ŽĤʬ
	#
	print HTMLFILE <<EOF;
<img src="../../${slidedir}/${htmlnumber}.${imgtype}" alt="$altmsg{$htmlnumber}">

EOF
	#
	# ڡΥå
	#
	if ($acktext) {
	    print HTMLFILE <<EOF;
<hr noshade size="1">
<div align="right">
EOF
	    local($_) = $acktext;
	    if ($acklink_out = $acklink) {
		${acklink_out} = "<b><a href=\"${acklink_out}\" target=\"_top\">";
		s/::/${acklink_out}/ || s/^/${acklink_out}/;
		${acklink_out} = "</a></b>";
		s/::/${acklink_out}/ || s/$/${acklink_out}/;
	    }
	    print HTMLFILE "$_\n";
	    print HTMLFILE ": at ", &FmtTime, "</div>\n";
	}
	#
	# եåκ
	#
	print HTMLFILE <<EOF;
</body>
</html>
EOF
	close(HTMLFILE);
	print STDOUT "${element_num}, " unless ($debug);
	# ǥХåѽ
	if ($debug) {
	    print STDOUT "  page: ${element_num}\n".
		         "    allpage : ${allpage_num}\n".
		         "    previous: ${previous_num}\n".
		         "    next    : ${next_num}\n".
		         "    html_num: ${htmlnumber}\n".
		         "    htmlfile: ${htmlfile}\n";
	}
	# Υ롼פ
	$element_num++;
    }
    # Υǥ쥯ȥ
    chdir("$current_dir");
    print STDOUT "  Back to $current_dir.\n" if ($debug);
    print STDOUT "done.\n" unless ($debug);
    return;
}

#
# ֽѥ֥롼
#
sub FmtTime {
	local($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
	 = localtime time;
	sprintf "%4d/%02d/%02d %02d:%02d:%02d",
		$year + 1900, $mon + 1, $mday, $hour, $min, $sec;
}

#
# ֥ͥ롼
#    - Хѿ @number  %info_hash  %altmsg 
#      (Ϥä, ϤʤäΤǥܤ)
#
sub MakeThumbnail() {
    local($title, $style_out, $jpcode, $metajp, $htmldir,
	  $thumnail_mode, $thumbnail_file, $thumbdir,
	  $thumbnail_link, $thumbnail_col_num,
	  $imgtype_thumb, $acktext, $acklink, $debug) = @_;
    # ǥեȤο
    local($thumbnail_col_num_def) = "3";

    # ǥХåѥå
    print STDOUT "MakeThumbnail: \$thumbnail_mode = $thumbnail_mode\n" if ($debug);
    # $thumnail_mode  (0) ʤв⤻˽λ
    return unless ($thumbnail_mode);

    # 桼, ǥХåѥå
    print STDOUT "Creating Thumbnail File ..." unless ($debug);
    if ($debug) {
	print STDOUT "  \$thumbnail_file = $thumbnail_file\n".
	             "  \$thumbdir = $thumbdir\n".
	             "  \$thumbnail_link = $thumbnail_link\n".
	             "  \$thumbnail_col_num = $thumbnail_col_num\n".
	             "  \$thumbdir = $thumbdir\n";
    }
    # ʸѴ
    &jcode'convert(*thumnail_link, "$jpcode");
    # 㳰
    unless ($thumbnail_col_num =~ /^\d+$/){
	print STDOUT "  Modify \$thumbnail_col_num ".
	    "from $thumbnail_col_num to $thumbnail_col_num_def.\n" if ($debug);
	$thumbnail_col_num = $thumbnail_col_num_def;
    }
    # ե륪ץ
    open(THUMBFILE, "> $thumbnail_file")
	|| die "顼: $thumbnail_file ˽񤭹ळȤޤǤ. /n";
    #
    # إåν񤭽Ф
    #
    print THUMBFILE <<EOF;
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=${metajp}">
  <title> $title Thumbnail</title>
$style_out
</head>
<body>

<hr noshade size="1">
<center>
  $title
</center>
<hr noshade size="1">


EOF
    #
    # ơ֥Υإåʬ񤭽Ф
    #
    print THUMBFILE <<EOF;
<table border="0" cellspacing="20" cellpadding="0" align="center">
EOF

    #
    # ͥʬ
    #

    # ֹȤ $element_num Ѱ
    local($element_num) = 0;

    while ($number[$element_num]) {
	local($thumbnum) = $number[$element_num];
	local($amari) = $thumbnum % $thumbnail_col_num;

	#
	# ơ֥֤ˤä <tr> ΤĤ򤪤ʤ.
	# ü : 3n+1 ($amari == 1)
	# ü : 3n   ($amari == 0)
	if ($amari == 1) {
	    print THUMBFILE <<EOF;
  <tr align="center" valign="bottom">
EOF
	}

        print THUMBFILE <<EOF;
    <td align="center" valign="top">
      <a href="../${htmldir}/${thumbnum}.html">
        <img src="../${thumbdir}/${thumbnum}.${imgtype_thumb}" border="2" alt="$altmsg{$thumbnum}">
      </a>
      <br>
      <small>
         $info_hash{$thumbnum}
      </small>
    </td>
EOF
	if ($amari == 0) {
	    print THUMBFILE <<EOF;
  </tr>
EOF
	}
	# ǥХåѽ
	if ($debug) {
	    print STDOUT "    ${thumbdir}/${thumbnum}.${imgtype_thumb} -> ".
		           "./${htmldir}/${thumbnum}.html\n";
	}
	$element_num++;
    }

    #
    # ơ֥Ƿ礱Ƥʬɲ
    #
    local($total) = $#number + 1 ; # ο
    local($total_amari) = $total % $thumbnail_col_num;
    local($total_nokori) = $thumbnail_col_num - $total_amari;
    local($i);
    # ǥХåѽ
    if ($debug) {
	print STDOUT "  \$total        = $total\n".
	             "  \$total_amari  = $total_amari\n".
	             "  \$total_nokori = $total_nokori\n";
    }
    
    for ($i = $total_nokori; $i > 0; $i--) {
	print THUMBFILE <<EOF;
    <td>&nbsp;</td>
EOF
    }
    if ($total_nokori) {
	print THUMBFILE <<EOF;
  </tr>
EOF
    }

    #
    # ơ֥Υեåʬ񤭽Ф
    #
    print THUMBFILE <<EOF;
</table>
EOF

    #
    # ڡΥå
    #
    if ($acktext) {
	print THUMBFILE <<EOF;
<hr noshade size="1">
<div align="right">
EOF
	local($_) = $acktext;
	if ($acklink_out = $acklink) {
	    ${acklink_out} = "<b><a href=\"${acklink_out}\" target=\"_top\">";
	    s/::/${acklink_out}/ || s/^/${acklink_out}/;
	    ${acklink_out} = "</a></b>";
	    s/::/${acklink_out}/ || s/$/${acklink_out}/;
	}
	print THUMBFILE "$_\n";
	print THUMBFILE ": at ", &FmtTime, "</div>\n";
    }

    #
    # եåν񤭽Ф
    #
    print THUMBFILE <<EOF;
</body>
</html>
EOF
    close(THUMBFILE);
    
    print STDOUT "done.\n" unless ($debug);
}



# λåɽ (ǥХå⡼ɻ)
#
sub EndMessage() {
    local($debug) = @_;
    print STDOUT "EndMessage: Execute Successfully!!\n" if ($debug);
    print STDOUT "Complete.\n" unless ($debug);
}


##################################################
#####                                        #####
##         README.TXT ϥ֥롼         ###
#####      (Ƥ README.TXT Υԡ)      #####
##################################################


sub PrintReadme() {
    print STDOUT <<'EOF';
 epppt (EPnetFaN PowerPoint ) å version 3 

   PowerPoint ե򸫤䤹 HTML Ѵ Perl ץ

 

   PowerPoint ϥץ쥼ơ, ͤ˸褦
   HTML ѴΤݤ.
   (PowerPoint ǡHTML¸פȤƤ⤽뤳ȤǤ
    , Windows Ǥʤ˸ʤȤä, ˤäƤ
    HTML ʤΤ⤢)

   ΥץȤΥåȤȤȤ, ɤΥץåȥեǤ
   뤳ȤǤ, 䤹(?)HTMLե뤳Ȥ.


 ʪ

   epppt.tar.gz եŸ뤳ȤǰʲΥե뤬Ǥ
   ϤǤ.

      epppt.pl          HTML եޥåȤPerlץ
      sample            ץ
      README.TXT        Υե

   (ȯѥġ)
      Makefile          make ѤΥե


 ץ (ޤ)

   sample ǥ쥯ȥˤ, epppt Υץ뤬֤Ƥ.
   (ΥץȤ뤫ɤ, ƥ epppt 
    Ȥ뤫ɤΥƥȤˤʤ)

    src/               
          title.txt     ץΥȥե
          menu.txt      ץΥ˥塼ե
          Slide*.PNG    饤ɤե
                          (PowerPoint ΡWeb ڡ¸פǺ)
    Makefile	        make ѥե
    epppt.ppt	        ץ ppt ե
    pub/              Ѥ־



    HTML 

      sample ˰ư, epppt ޥɤ¹Ԥ

        $ cd sample
	$ perl ../epppt.pl -x

      , pub ǥ쥯ȥʲ, index.html ,
      줿 HTML ǤϤǤ.

      ֥饦Ǽºݤ˸Ƥߤߤ

      
    

       HTML õ, ,

        $ make clean

      Ȥɤ.


 HTML 

    Windows ǹԤ

      ޤ, Windows ¦ ppt ե뤫եɬפ.

      PowerPoint Ρ֥եעWebڡ¸פȤơ
      ֥եμפ gif, jpeg, png Τɤ줫򤹤롣
      ֥ץ쥼ơΥ饤ɤƥݡȤޤפ
      ֤Ϥפ롣

      , PowerPoint Υե̾ƱΥǥ쥯ȥ
      ¸Τ, 줴 Linux ĶΥޥ
      (Web ФǤǤ礦) ˥ԡ.


    Linux (Web )ǹԤ

      0. epppt.pl ѤǤ뤿ˤ...

	 a. perl Ȥ
	    - 칶 Web ФʤɬȤ
	    - perl 5.6.1 ưǧ

	    -  ѥ˴ؤ 
		 epppt.pl  Debian δĶǺΤ
		 perl Υѥ /usr/bin/perl ȤʤäƤ.
		 ¾ OS ξϥѥۤʤ礬Τ
		 ѹ뤳
		 (perl Υѥ which perl ȤΤ뤳ȤǤ)

		 ѹ, epppt.pl Τΰ־ιԤ
		 #!/usr/bin/perlפ񤭴Ф褤

	 b. jcode.pl Ȥ (ܸʸѥ饤֥Ǥ)
	    - 칶 Web ФʤɬȤ
	    - Debian GNU/Linux 3.0 ʤ, libjcode-perl ѥå
	      󥹥ȡ뤹뤳Ȥ, ƥȤ߹
	    - jcode.pl ܲȤǤ http://srekcah.org/jcode/ 
	      ɤ, jcode.pl ˥ե̾Ѵ,
	      ץ¹ԤݤΥȥǥ쥯ȥ,
	      /usr/lib/perl5 ֤ɤ

	 c. ImageMagic Ȥ (ΤǤ)
	    - 칶 Web ФʤɬȤ
	    - Debian GNU/Linux 3.0 ʤ, imagemagic ѥå
	      󥹥ȡ뤹뤳Ȥ, ƥȤ߹

         ʤ, ưǧΤ sample ǥ쥯ȥ꤬ѰդƤ.
	 ⤷ⲼμˤäƤޤԤʤ,
	 sample ʲǰʲΤ褦ưåԤʤäߤ.

	    $ make clean
	    $ make

      1. ե뤬äƤǥ쥯ȥ src ѹ

            $ mv <ǥ쥯ȥ> src

      2. epppt -x ¹

            $ epppt -x

      3. 

             եǤ src/Config.epppt ޤ.
               1. epppt ǥեȤǽ򤹤ʤ "y",
               2. Ǥʤ                     "n",
               3. src/Config.epppt ƥץ졼ȤϤʤ"m"
             ϤƤ [Y/n/m]: 

	 ʹ뤬Τޤ Enter

      4. ȥ

             ȥƲ.
	       Title []:

	 ˥饤ɤΥȥ. (Ǥ¹Ԥϲǽ)
	  
      5. 

         Ϥ. (ܤϲνʤ
	 ΤǾ֤).

	     Get Names of Image in src ...  done.
	     Prepare Names of image files in publish directory ...  done.
	     Get ImageType from pub/menu ...done.
	     Get ImageType from pub/slide ...done.
	     Get ImageType from pub/thumbnail ...done.
	     Get Slide Informations from src/menu.txt ...  done
	     Recognize Japanese Code is euc ...done.
	     Creating Index File ...done.
	     Creating Menu File ...done.
	     Creating Menu File ...done.
	     Removing Old HTML Files ...done.
	     Creating HTML Files ...0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, done.
	     Creating Thumbnail File ...done.
	     Complete.

	 ǸˡCompleteפǤȴλ.
	
      7. Ǥǧ

         pub/index.html 줿ΤΥǥå֤Τ
	 ߤƤߤ.


    ޤ

      1. ˥塼񤭹

         src/menu.txt ˾񤭹ळȤʸ˥塼
	 񤭽ФȤ.
	 
	 񼰤

		001:<1ĤΥ饤ɤ>
		002:<2ĤΥ饤ɤ>
		003:<3ĤΥ饤ɤ>
			    :

	 Ȥʤ. Ūˤ

		001:Ϥ
		002:ܼ
		003:BIOSä?
		     :

	 Ƚ񤭽Фɤ.

	  sample  menu.txt 򻲾Ȥߤ.

	 񤭽ä,  epppt.pl ¹Ԥ

	    $ epppt.pl -q

	 ¹Ԥɤ. ɤ褦˥ȥ񤭴
	 src/title.txt 񤭴ɤ.
	 
      
      2. 񼰤򤤤ѹ

         ե src/Config.epppt 񤭴뤳ȤǸɤ
	 ѹ뤳ȤǽǤ. src/Config.epppt 

	    $ epppt.pl -x

	 Ȥ, 

             եǤ src/Config.epppt ޤ.
               1. epppt ǥեȤǽ򤹤ʤ "y",
               2. Ǥʤ                     "n",
               3. src/Config.epppt ƥץ졼ȤϤʤ"m"
             ϤƤ [Y/n/m]:
	     
         ˡmפ򲡤 Enter 뤳Ȥ.
	    
	 src/Config.epppt  emacs  jvim ʤɤܸɽǽ
	 ǥǳ, Խ.

	  

	    Ƽեǥ쥯ȥ꤬ǽǤ뤬, Ū
	    ɬפ̵. (ĤȤѹȥڤʤ
	    ǽ⤤ΤѹʤȤ򶯤侩). 
	    κݤˤ, 嵭ѰդƤեǥ쥯ȥ̾
	    򤽤碌ѹɬפ.


	  ˥塼ե

	      # ˥塼ե (᡼)
	      $menufile = "${pubdir}/menu.html";
	      #$menufile = "";      # ǥ˥塼ե뤬ʤ
	      
	      # ˥塼ե (ƥ)
	      $menutxtfile = "${pubdir}/menutxt.html";
	      #$menutxtfile = "";   # ƥǥ˥塼ե뤬ʤ

            ˥塼եˤϲǤȥƥǤѰդƤ뤬,
	    ɤ餫ɬפʤ, ǤϥȥȤƤ
	    ΤιƬΡ#פɤ.

	    ξ, ʲ⤽ˤ碌ʤ
	    ˥塼ɽʤʤäꤹΤ.

	      # ưΥǥեȤΥڡ
	      # ڡ
	      $defaultleft  = "$menufile";     # ᡼˥塼
	      #$defaultleft  = "$menutxtfile";  # ƥȥ˥塼
	      # ڡ
	      $defaultright = "$thumbnail_file";    # ͥ
	      #$defaultright = "$htmldir/001.html";  # 1 ڡ

	      
	  

	      ##############################
	      ###  
	      ##
	      # ˥塼Υ
	      $menusize = "120x90";
	      # 饤ɤΥ
	      $slidesize = "640x480";
	      # ͥΥ
	      $thumbsize = "200x150";

	    Խ뤳ȤǲѹǽǤ.


	  ٤

	      ##############################
	      ###  ٤
	      ##
              $depth = "8";      # 0: -depth ץѤʤ

	    Խ뤳Ȥ convert ޥɤ -depth ץ
	    ꤹͤѹǤ. ʤۤɲ
	    ʤ뤬, ϹӤʤ.  0 ˤ, -depth
            ץѤ convert ΥǥեȤνǤ.


	  ʸ

	      # Ϥեܸʸ
	      # "jis", "euc", "sjis" Τɤ줫
	      $jpcode = "euc";
	      $system_code = "euc";

	    $jpcode ΥǥեȤ euc , Windows Ķοͤʤɤ
	    sjis ǤɤΤΤʤ.  (嵭˳ΰʳ
	    Ϥeuc ˤʤΤ.)

	    ʤ, $system_code  epppt.pl ưץåȥե
	    Υǥեʸɤɬ碌ߤ.


	  

	      # 0: ̵, 1: 뤢
	      $style_mode = "1";
	          # ƥȤο
	      $style_textcolor       = '#999900';
		          :

	    ʸοطʿ꤬ǽǤ.
	    ѿꤷߤ.
	    ꤬ݤʾ $style_mode  0 ˤ뤳Ȥ,
	    ̵ˤǤ.

	      
	      # ΥڡؤΥ󥯤Ѥʸ
	      $previouslink = '[Prev]';
	      $nextlink     = '[Next]';

	    饤ɤΥڡֺݤΥ󥯤Υå
	    Ǥ.

	      $upperlink = 'Parent Dirctory';
	      $upperurl  = '';
	      $lowerlink = 'ppt ե뢧';
	      $lowerurl  = '';

	    ˽Ф˥塼ξ岼˥󥯤դ뤳ȤǤ.
	    $upperlink, $lowerlink ʸλ,
	    $upperurl, $lowerurl  URL λԤʤ.
	     $upperlink  $lowerlink ʤΤ,
	    ѹƤ⹽ʤ.
	    Ĥ, 줾, ɤ餫ǤˤʤäƤ
	    󥯤ΤΤǤʤΤ.


	  ͥ

	      # 0: ̵ͥ, 1: ͥ뤢
	      $thumbnail_mode    = "1";
	          # ͥؤΥ󥯤Υå
	      $thumbnail_link    = "[[ Thumbnail ]]";
		  # ͥο
	      $thumbnail_col_num = "3";

	    ͥԤʤ.

	 񤭽ä,  epppt.pl ¹Ԥ

	    $ epppt.pl -q

	 ¹Ԥɤ. ɤ褦˥ȥ񤭴
	 src/title.txt 񤭴ɤ.

EOF
}
